import { Widget, Message, AbstractViewContribution } from '@theia/core/lib/browser';
import { BaseWidget } from '@theia/core/lib/browser/widgets/widget';
import { FxdkDataService } from 'fxdk-services/lib/browser/fxdk-data-service';
export declare const RESMON_WIDGET_ID = "fxdk-resmon";
export declare const RESMON_WIDGET_ICON = "fa fa-dashboard";
interface ResourceNode {
    row: HTMLTableRowElement;
    clientCpu: HTMLTableCellElement;
    serverCpu: HTMLTableCellElement;
    clientTime: HTMLTableCellElement;
    serverTime: HTMLTableCellElement;
    clientMemory: HTMLTableCellElement;
    serverMemory: HTMLTableCellElement;
    streaming: HTMLTableCellElement;
}
export declare class ResmonWidget extends BaseWidget {
    protected readonly dataService: FxdkDataService;
    protected tbodyNode: HTMLTableSectionElement | null;
    protected resourceNodes: Record<string, ResourceNode>;
    protected init(): void;
    private renderResourcesData;
    private getOrCreateResourceNode;
    private deleteResourceNode;
    protected onActivateRequest(msg: Message): void;
    protected onAfterShow(msg: Message): void;
    protected onAfterAttach(msg: Message): void;
    protected onBeforeDetach(msg: Message): void;
    protected onResize(msg: Widget.ResizeMessage): void;
    private initialized;
    protected onUpdateRequest(msg: Message): void;
    private updateScroll;
}
export declare class ResmonWidgetViewContribution extends AbstractViewContribution<ResmonWidget> {
    static readonly TOGGLE_COMMAND_ID = "Z_fxdkResmon:toggle";
    constructor();
}
export {};
//# sourceMappingURL=combined-resmon.d.ts.map